import nanopb_pb2 as _nanopb_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class LogEntry(_message.Message):
    __slots__ = ("message",)
    MESSAGE_FIELD_NUMBER: _ClassVar[int]
    message: str
    def __init__(self, message: _Optional[str] = ...) -> None: ...

class BoardIdentification(_message.Message):
    __slots__ = ("commit_hash", "version", "board_id", "board_type")
    COMMIT_HASH_FIELD_NUMBER: _ClassVar[int]
    VERSION_FIELD_NUMBER: _ClassVar[int]
    BOARD_ID_FIELD_NUMBER: _ClassVar[int]
    BOARD_TYPE_FIELD_NUMBER: _ClassVar[int]
    commit_hash: str
    version: str
    board_id: str
    board_type: str
    def __init__(self, commit_hash: _Optional[str] = ..., version: _Optional[str] = ..., board_id: _Optional[str] = ..., board_type: _Optional[str] = ...) -> None: ...

class BoardIdentificationRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class MeasurementSample(_message.Message):
    __slots__ = ("adc_sample", "pulse_len_us", "min_amp", "max_amp", "mean_amp", "lin_fit_slope", "lin_fit_offset", "lin_fit_valid", "exp_fit_exponent", "exp_fit_intercept", "exp_fit_valid", "integral", "weighted_delta_ref", "mean_amp_filtered")
    ADC_SAMPLE_FIELD_NUMBER: _ClassVar[int]
    PULSE_LEN_US_FIELD_NUMBER: _ClassVar[int]
    MIN_AMP_FIELD_NUMBER: _ClassVar[int]
    MAX_AMP_FIELD_NUMBER: _ClassVar[int]
    MEAN_AMP_FIELD_NUMBER: _ClassVar[int]
    LIN_FIT_SLOPE_FIELD_NUMBER: _ClassVar[int]
    LIN_FIT_OFFSET_FIELD_NUMBER: _ClassVar[int]
    LIN_FIT_VALID_FIELD_NUMBER: _ClassVar[int]
    EXP_FIT_EXPONENT_FIELD_NUMBER: _ClassVar[int]
    EXP_FIT_INTERCEPT_FIELD_NUMBER: _ClassVar[int]
    EXP_FIT_VALID_FIELD_NUMBER: _ClassVar[int]
    INTEGRAL_FIELD_NUMBER: _ClassVar[int]
    WEIGHTED_DELTA_REF_FIELD_NUMBER: _ClassVar[int]
    MEAN_AMP_FILTERED_FIELD_NUMBER: _ClassVar[int]
    adc_sample: _containers.RepeatedScalarFieldContainer[float]
    pulse_len_us: int
    min_amp: float
    max_amp: float
    mean_amp: float
    lin_fit_slope: float
    lin_fit_offset: float
    lin_fit_valid: bool
    exp_fit_exponent: float
    exp_fit_intercept: float
    exp_fit_valid: bool
    integral: float
    weighted_delta_ref: float
    mean_amp_filtered: float
    def __init__(self, adc_sample: _Optional[_Iterable[float]] = ..., pulse_len_us: _Optional[int] = ..., min_amp: _Optional[float] = ..., max_amp: _Optional[float] = ..., mean_amp: _Optional[float] = ..., lin_fit_slope: _Optional[float] = ..., lin_fit_offset: _Optional[float] = ..., lin_fit_valid: bool = ..., exp_fit_exponent: _Optional[float] = ..., exp_fit_intercept: _Optional[float] = ..., exp_fit_valid: bool = ..., integral: _Optional[float] = ..., weighted_delta_ref: _Optional[float] = ..., mean_amp_filtered: _Optional[float] = ...) -> None: ...

class DetectionMeasurement(_message.Message):
    __slots__ = ("timestamp_us", "sample", "amplitude", "phase")
    TIMESTAMP_US_FIELD_NUMBER: _ClassVar[int]
    SAMPLE_FIELD_NUMBER: _ClassVar[int]
    AMPLITUDE_FIELD_NUMBER: _ClassVar[int]
    PHASE_FIELD_NUMBER: _ClassVar[int]
    timestamp_us: int
    sample: MeasurementSample
    amplitude: float
    phase: float
    def __init__(self, timestamp_us: _Optional[int] = ..., sample: _Optional[_Union[MeasurementSample, _Mapping]] = ..., amplitude: _Optional[float] = ..., phase: _Optional[float] = ...) -> None: ...

class ReferenceMeasurement(_message.Message):
    __slots__ = ("timestamp_us", "sample")
    TIMESTAMP_US_FIELD_NUMBER: _ClassVar[int]
    SAMPLE_FIELD_NUMBER: _ClassVar[int]
    timestamp_us: int
    sample: MeasurementSample
    def __init__(self, timestamp_us: _Optional[int] = ..., sample: _Optional[_Union[MeasurementSample, _Mapping]] = ...) -> None: ...

class SamplingConfiguration(_message.Message):
    __slots__ = ("pulse_len_us", "pulse_period_us", "frontend_manual_offset", "frontend_manual_offset_control", "num_samples_analyze", "num_samples_skip", "num_oversample_reference", "num_oversample_measurement", "gain_level", "num_undersample_processing", "ref_sample_update_period_us", "auto_offset_adjustment_range_min", "auto_offset_adjustment_range_max")
    class FrontendGainLevel(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        GAIN0: _ClassVar[SamplingConfiguration.FrontendGainLevel]
        GAIN1: _ClassVar[SamplingConfiguration.FrontendGainLevel]
        GAIN2: _ClassVar[SamplingConfiguration.FrontendGainLevel]
        GAIN3: _ClassVar[SamplingConfiguration.FrontendGainLevel]
    GAIN0: SamplingConfiguration.FrontendGainLevel
    GAIN1: SamplingConfiguration.FrontendGainLevel
    GAIN2: SamplingConfiguration.FrontendGainLevel
    GAIN3: SamplingConfiguration.FrontendGainLevel
    PULSE_LEN_US_FIELD_NUMBER: _ClassVar[int]
    PULSE_PERIOD_US_FIELD_NUMBER: _ClassVar[int]
    FRONTEND_MANUAL_OFFSET_FIELD_NUMBER: _ClassVar[int]
    FRONTEND_MANUAL_OFFSET_CONTROL_FIELD_NUMBER: _ClassVar[int]
    NUM_SAMPLES_ANALYZE_FIELD_NUMBER: _ClassVar[int]
    NUM_SAMPLES_SKIP_FIELD_NUMBER: _ClassVar[int]
    NUM_OVERSAMPLE_REFERENCE_FIELD_NUMBER: _ClassVar[int]
    NUM_OVERSAMPLE_MEASUREMENT_FIELD_NUMBER: _ClassVar[int]
    GAIN_LEVEL_FIELD_NUMBER: _ClassVar[int]
    NUM_UNDERSAMPLE_PROCESSING_FIELD_NUMBER: _ClassVar[int]
    REF_SAMPLE_UPDATE_PERIOD_US_FIELD_NUMBER: _ClassVar[int]
    AUTO_OFFSET_ADJUSTMENT_RANGE_MIN_FIELD_NUMBER: _ClassVar[int]
    AUTO_OFFSET_ADJUSTMENT_RANGE_MAX_FIELD_NUMBER: _ClassVar[int]
    pulse_len_us: int
    pulse_period_us: int
    frontend_manual_offset: float
    frontend_manual_offset_control: bool
    num_samples_analyze: int
    num_samples_skip: int
    num_oversample_reference: int
    num_oversample_measurement: int
    gain_level: SamplingConfiguration.FrontendGainLevel
    num_undersample_processing: int
    ref_sample_update_period_us: int
    auto_offset_adjustment_range_min: int
    auto_offset_adjustment_range_max: int
    def __init__(self, pulse_len_us: _Optional[int] = ..., pulse_period_us: _Optional[int] = ..., frontend_manual_offset: _Optional[float] = ..., frontend_manual_offset_control: bool = ..., num_samples_analyze: _Optional[int] = ..., num_samples_skip: _Optional[int] = ..., num_oversample_reference: _Optional[int] = ..., num_oversample_measurement: _Optional[int] = ..., gain_level: _Optional[_Union[SamplingConfiguration.FrontendGainLevel, str]] = ..., num_undersample_processing: _Optional[int] = ..., ref_sample_update_period_us: _Optional[int] = ..., auto_offset_adjustment_range_min: _Optional[int] = ..., auto_offset_adjustment_range_max: _Optional[int] = ...) -> None: ...

class SamplingConfigurationRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class PerformReferenceMeasurement(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class AutomaticOffsetAdjustmentRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ThresholdConfiguration(_message.Message):
    __slots__ = ("sensitivity", "noiseFloorMultiplier", "detectionStatistic", "compute_expensive_stats", "minNoiseFloor", "dynamicModeAlpha", "normalizedSensitivity")
    class DetectionStatistic(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
        __slots__ = ()
        MEAN_AMPLITUDE: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        INTEGRAL: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        WEIGHTED_DELTA: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        LINEAR_FIT_SLOPE: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        LINEAR_FIT_OFFSET: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        EXPONENTIAL_FIT_EXPONENT: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        EXPONENTIAL_FIT_INTERCEPT: _ClassVar[ThresholdConfiguration.DetectionStatistic]
        MEAN_AMPLITUDE_FILTERED: _ClassVar[ThresholdConfiguration.DetectionStatistic]
    MEAN_AMPLITUDE: ThresholdConfiguration.DetectionStatistic
    INTEGRAL: ThresholdConfiguration.DetectionStatistic
    WEIGHTED_DELTA: ThresholdConfiguration.DetectionStatistic
    LINEAR_FIT_SLOPE: ThresholdConfiguration.DetectionStatistic
    LINEAR_FIT_OFFSET: ThresholdConfiguration.DetectionStatistic
    EXPONENTIAL_FIT_EXPONENT: ThresholdConfiguration.DetectionStatistic
    EXPONENTIAL_FIT_INTERCEPT: ThresholdConfiguration.DetectionStatistic
    MEAN_AMPLITUDE_FILTERED: ThresholdConfiguration.DetectionStatistic
    SENSITIVITY_FIELD_NUMBER: _ClassVar[int]
    NOISEFLOORMULTIPLIER_FIELD_NUMBER: _ClassVar[int]
    DETECTIONSTATISTIC_FIELD_NUMBER: _ClassVar[int]
    COMPUTE_EXPENSIVE_STATS_FIELD_NUMBER: _ClassVar[int]
    MINNOISEFLOOR_FIELD_NUMBER: _ClassVar[int]
    DYNAMICMODEALPHA_FIELD_NUMBER: _ClassVar[int]
    NORMALIZEDSENSITIVITY_FIELD_NUMBER: _ClassVar[int]
    sensitivity: float
    noiseFloorMultiplier: float
    detectionStatistic: ThresholdConfiguration.DetectionStatistic
    compute_expensive_stats: bool
    minNoiseFloor: float
    dynamicModeAlpha: float
    normalizedSensitivity: float
    def __init__(self, sensitivity: _Optional[float] = ..., noiseFloorMultiplier: _Optional[float] = ..., detectionStatistic: _Optional[_Union[ThresholdConfiguration.DetectionStatistic, str]] = ..., compute_expensive_stats: bool = ..., minNoiseFloor: _Optional[float] = ..., dynamicModeAlpha: _Optional[float] = ..., normalizedSensitivity: _Optional[float] = ...) -> None: ...

class ThresholdConfigurationRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ThresholdStatusReport(_message.Message):
    __slots__ = ("noiseFloor", "meanValue", "meanValueSlope", "minValue", "measuredNoiseFloor")
    NOISEFLOOR_FIELD_NUMBER: _ClassVar[int]
    MEANVALUE_FIELD_NUMBER: _ClassVar[int]
    MEANVALUESLOPE_FIELD_NUMBER: _ClassVar[int]
    MINVALUE_FIELD_NUMBER: _ClassVar[int]
    MEASUREDNOISEFLOOR_FIELD_NUMBER: _ClassVar[int]
    noiseFloor: float
    meanValue: float
    meanValueSlope: float
    minValue: float
    measuredNoiseFloor: float
    def __init__(self, noiseFloor: _Optional[float] = ..., meanValue: _Optional[float] = ..., meanValueSlope: _Optional[float] = ..., minValue: _Optional[float] = ..., measuredNoiseFloor: _Optional[float] = ...) -> None: ...

class NoiseFloorMeasurementRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class RawSample(_message.Message):
    __slots__ = ("timestamp_us", "adc_sample")
    TIMESTAMP_US_FIELD_NUMBER: _ClassVar[int]
    ADC_SAMPLE_FIELD_NUMBER: _ClassVar[int]
    timestamp_us: int
    adc_sample: _containers.RepeatedScalarFieldContainer[int]
    def __init__(self, timestamp_us: _Optional[int] = ..., adc_sample: _Optional[_Iterable[int]] = ...) -> None: ...

class SystemStatus(_message.Message):
    __slots__ = ("timestamp_us", "processed_sample_rate", "battery_voltage", "battery_soc", "mcu_temperature_c", "adc_read_sample_rate", "headphones_detected")
    TIMESTAMP_US_FIELD_NUMBER: _ClassVar[int]
    PROCESSED_SAMPLE_RATE_FIELD_NUMBER: _ClassVar[int]
    BATTERY_VOLTAGE_FIELD_NUMBER: _ClassVar[int]
    BATTERY_SOC_FIELD_NUMBER: _ClassVar[int]
    MCU_TEMPERATURE_C_FIELD_NUMBER: _ClassVar[int]
    ADC_READ_SAMPLE_RATE_FIELD_NUMBER: _ClassVar[int]
    HEADPHONES_DETECTED_FIELD_NUMBER: _ClassVar[int]
    timestamp_us: int
    processed_sample_rate: int
    battery_voltage: float
    battery_soc: int
    mcu_temperature_c: float
    adc_read_sample_rate: int
    headphones_detected: bool
    def __init__(self, timestamp_us: _Optional[int] = ..., processed_sample_rate: _Optional[int] = ..., battery_voltage: _Optional[float] = ..., battery_soc: _Optional[int] = ..., mcu_temperature_c: _Optional[float] = ..., adc_read_sample_rate: _Optional[int] = ..., headphones_detected: bool = ...) -> None: ...

class SetSimulatedStateRequest(_message.Message):
    __slots__ = ("battery_voltage", "has_battery_voltage", "vibro_pwm_dc", "has_vibro_pwm_dc")
    BATTERY_VOLTAGE_FIELD_NUMBER: _ClassVar[int]
    HAS_BATTERY_VOLTAGE_FIELD_NUMBER: _ClassVar[int]
    VIBRO_PWM_DC_FIELD_NUMBER: _ClassVar[int]
    HAS_VIBRO_PWM_DC_FIELD_NUMBER: _ClassVar[int]
    battery_voltage: float
    has_battery_voltage: bool
    vibro_pwm_dc: float
    has_vibro_pwm_dc: bool
    def __init__(self, battery_voltage: _Optional[float] = ..., has_battery_voltage: bool = ..., vibro_pwm_dc: _Optional[float] = ..., has_vibro_pwm_dc: bool = ...) -> None: ...

class BoardRebootRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class RestoreDefaultConfigurationRequest(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...
